import { CountDocumentsOptions, Filter, UpdateFilter, UpdateOptions } from 'mongodb'
import { MongoDocument, MongoCollection, MongoDatabase, MongoCollectionOptions } from './mongo'

export class Collection<T extends MongoDocument> extends MongoCollection<T> {
    constructor(database: MongoDatabase, collectionName: string, options: MongoCollectionOptions = {}) {
        // eslint-disable-next-line @typescript-eslint/ban-ts-comment
        // @ts-expect-error
        super(database, collectionName, options)
    }

    countDocuments(filter?: Filter<T>, options?: CountDocumentsOptions): Promise<number> {
        return super.countDocuments(filter, options)
    }

    upsert(filter: Filter<T>, update: UpdateFilter<T> | Partial<T>, options?: UpdateOptions) {
        return super.updateOne(filter, update, {
            upsert: true,
            ...options
        })
    }
}
